######  [English](https://github.com/kalcaddle/kodbox/blob/master/README.md) | [中文文档](https://github.com/kalcaddle/kodbox/blob/master/README_zh-CN.md)

<h2 align="center">
  <a href="http://kodcloud.com/" alt="logo" target="_blank"><img src="https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/icon_512.png" width="120"/></a>
  <br><br><b>kodbox</b><br>
</h2>
<h4 align="center">Multi-cloud • Filemanager • Collaboration</h4>
<p align="center">
  <a href="http://kodcloud.com/" target="_blank">Home</a> •
  <a href="https://kodcloud.com/download/" target="_blank">Download</a> •
  <a href="https://doc.kodcloud.com/v2/#/" target="_blank">Doc</a>  • 
  <a href="https://github.com/kalcaddle/kodbox/blob/master/ChangeLog.md" target="_blank">Changelog</a>
</p>

> kodbox is a file manager for web. It is also a web code editor, which allows you to develop websites directly within the web browser. Self-hosted file management system with muilt-cloud support. You can run kodbox either online or locally,on Linux, Windows or Mac based platforms. The only requirement is to have PHP 5 available.
>
> ----
> ### [Demo](http://demo.kodcloud.com/) [user: demo/demo]

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/folder-1.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/desktop-2.png)



## ✨ Features：
* 🚀 Private cloud disk/enterprise network disk like Windows experience
* 🌟 Full support for private deployment, secure and controllable storage
* 👁️‍🗨️ Online preview, editing and playback of hundreds of file formats, both office and entertainment
* 🚀 Multi-storage fusion: support local disk, ftp, webdav, Alibaba Cloud OSS, Tencent Cloud COS, Qiniu, minio, S3 compatible protocol, etc.
* 🔗 Easy sharing, efficient collaboration, fine-grained permission control
* 💻 Full platform client coverage, access anytime, anywhere, easy synchronization mounting; web, H5, iOS, Android, PC, webdav mounting


## ⚡ Detailed functions：
- **File operation**: highly consistent operation experience with Windows, including new creation, copy, move, paste, upload, download, delete, decompress, open mode, file sorting, view, etc.
- **Document selection**: box selection, drag and drop, shortcut keys, cloud document management is as familiar and efficient as local operation; file check, ctrl click, shift continuous selection, shortcut key selection (ctrl/shift+a/up/down/left/right/home/end...), first letter quick positioning, pinyin fuzzy search quick filtering...
- **Global drag and drop**: drag and drop files and folders to move and copy; drag and drop local files/folders to upload; drag and drop to the desktop to automatically download; drag and drop to the folder to automatically enter, drag and drop multiple file management windows to each other...
- **Efficient shortcut keys**: ctrl+c to copy, ctrl+x to cut, ctrl+v to paste, ctrl+z to undo, f2 to rename, ctrl+shift+z to undo, file view switching...
- **Right-click menu**: folders, files, and different types of files have fully adaptive right-click menus
- **File viewing mode**: It combines the strengths of Windows and Mac, supports "icon mode/list mode/column mode" file management, icon mode supports custom icon size, and list mode folders support tree directory expansion; automatically records the viewing mode of each folder; uses virtual lists to quickly and efficiently manage a large number of file folders.
- **Multi-dimensional document management**: Favorites; document tags; file classification; recent documents; albums; recycle bin; department document public tags; personal file private safe...;
- **Convenient property panel**: All kinds of document attribute information, sharing status, picture exif information, music and video and other types of file information are clear at a glance; folders contain file folder quantity, size statistics, set notes, edit lock/top; can discuss file folders;
- **File history version**: Files are edited and saved online, and history versions are automatically generated, so there is no need to worry about content loss;
- **File deduplication/second transfer**: Using COW mechanism, file metadata records double hash authentication, automatic full deduplication, when uploading, files that already exist will be automatically transferred in seconds, saving storage space and improving upload efficiency; Folder movement and copying are completed quickly;
- **Advanced search**: Supports filtering or searching by type, file size, last modified time and other dimensions, supports Chinese pinyin pinyin initial letter search, supports document tag, note search; supports batch search of multiple file names, and presents search results in the order of search
- **Document dynamics**: All operation changes of file folders are clear at a glance, and the entire life cycle of the document is tracked;
- **Online decompression**: Supports online decompression of zip, tar, gz, 7z, rar and other files, supports quick creation of compressed packages for folders, and supports online preview of compressed packages
- **File online preview**: Anytime, anywhere, hundreds of common format documents can be easily viewed with a browser, without downloading to the local computer or installing software on the terminal; multimedia such as pictures, music, and videos; online preview and editing of Office documents; PDF, OFD, XPS and other version documents; online preview and editing of PhotoShop and Illustrator; AutoCAD engineering drawings
- **Text editor**: Provide powerful online text file editing function; support 120 code language highlighting; adaptive text encoding, say goodbye to file garbled; multiple tags support; support js/json/php/css and other language methods for quick viewing and file formatting; html files support real-time and safe preview; support fragment loading, easy online opening of large files; support hex mode, convenient viewing of binary files;
- **markdown editing**: The editor provides powerful and complete markdown editing function, supports real-time preview; shortcut key support; supports inserting formulas, flowcharts, sequence diagrams, uml diagrams, supports prompt references, supports html syntax; supports image relative path references; supports direct pasting of images copied from the clipboard; link jumps support other md files with relative paths;
- **Flowchart/Mind Map**: Draw Visio flowcharts and mind maps online and quickly share them with others;
- **Fine-grained permission control**: department files, folders, each file can set different permissions for different people or groups, thousands of faces;
- **External link sharing**: Share files (folders) with customers or external partners with one click, support setting access passwords, validity periods and multiple permissions; recipients can easily preview documents in multiple formats through links; when editing is enabled, recipients can edit, upload and collaborate on office files online; folders support default settings for document mode, convenient publishing of user manuals, development documents, etc.;
- **Internal collaboration**: You can initiate collaboration and grant different permissions to members, departments, or any combination within the system.
- **Collaboration Enhancement**: Provides department labels, document discussions, file dynamics, historical versions, editing locks and other components to gather the work results of multiple people.
-----
- **Login Control**: Login device control, double verification, login IP filtering, login verification code, complex password policy, anti-brute force cracking; scan code login (App scan code to log in to the web terminal; scan the logged in web terminal to log in to the App)
- **Permission Control**: Role permissions, department permissions, fine-grained document permissions, sharing control, content/authorization approval, multi-level administrators
- **Behavior Audit**: Login log, operation log, sharing content control, dynamic security watermark, sensitive word filtering, file confidentiality management, system recycle bin
- **Data Security**: Data backup, system restore, multi-cloud fusion storage, csrf protection, cluster deployment support
- **Multi-storage Fusion**: Local disk, ftp, webdav, Alibaba Cloud OSS, Tencent Cloud COS, Qiniu, minio, S3 and other multi-cloud fusion mounting, easy to handle cross-cloud file management, backup transmission, elastic expansion
- **Plug-in Center**: AD domain/enterprise WeChat/DingTalk and other 30+ enterprise-level application plug-ins can be freely expanded; file format editing and preview can be easily expanded; open plug-in development documents, enterprises can flexibly expand functions in the form of plug-ins according to needs; provide SDK to seamlessly embed the cloud file capabilities of enterprises into ERP, OA, mailbox and other IT systems
- **App**: Android, iOS full-end support; automatic album backup;
- **PC client**: Windows, Mac versions support; support folder backup to the cloud; automatically mount to local disk, no-feel operation, local experience; support calling PC software to preview and edit online files

## 🛠️ Install
```
# Install from source
git clone https://github.com/kalcaddle/kodbox.git
chmod -Rf 777 ./kodbox/*

# Install via download
wget https://github.com/kalcaddle/kodbox/archive/refs/heads/main.zip
unzip main.zip
chmod -Rf 777 ./*
```

- Suggest server: php8.1+mysql5.7+redis; 
- Upload speed and other configuration optimization:  http://doc.kodcloud.com/v2/#/help/options

### nginx rewrite
```
location / {
  if ( !-e $request_filename){
      rewrite ^[^index\.php](.*)$ /index.php?$1 last;
  }
}
```


## Software requirements
- Server:
    - Windows,Linux,Mac ...
    - PHP 5.3+
    - Database: sqlite;mysql;...
- Browser compatibility: 
    - Chrome 
    - Firefox
    - Opera
    - IE9+
> Tips: It can also run on a router, or your home NAS


## Screenshot
------

### Desktop
![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/desktop-1.png)

<!--![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/desktop-2.png)-->

### File manage
![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/folder-3.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/folder-2.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/folder-4.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/folder-5.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/folder-6.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/folder-7.png)


### User
![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/user-1.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/user-2.png)

### Admin area
![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/admin-1.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/admin-2.png)

![img](https://raw.githubusercontent.com/kalcaddle/static/master/images/kodbox/admin-3.png)



## License
kodcloud is issued under GPLv3.   license.[License](http://kodcloud.com/tools/licenses/license.txt)  
Contact: kalcaddle#qq.com  
Copyright (C) 2013 kodcloud.com  
